
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Journal_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.create(
            {
                id: data.id || undefined,
        
        debit_amount: data.debit_amount
        ||
        null
            ,
            
        credit_amount: data.credit_amount
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await journal_lines.setJournal_entry( data.journal_entry || null, {
            transaction,
        });
        
        await journal_lines.setGl_account( data.gl_account || null, {
            transaction,
        });
        
        await journal_lines.setItem( data.item || null, {
            transaction,
        });
        
        await journal_lines.setProduction_order( data.production_order || null, {
            transaction,
        });
        
        await journal_lines.setSupplier( data.supplier || null, {
            transaction,
        });
        
        await journal_lines.setCustomer( data.customer || null, {
            transaction,
        });
        

        

        

        return journal_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const journal_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                debit_amount: item.debit_amount
            ||
            null
            ,
            
                credit_amount: item.credit_amount
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const journal_lines = await db.journal_lines.bulkCreate(journal_linesData, { transaction });

        // For each item created, replace relation files
        

        return journal_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const journal_lines = await db.journal_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.debit_amount !== undefined) updatePayload.debit_amount = data.debit_amount;
        
        
        if (data.credit_amount !== undefined) updatePayload.credit_amount = data.credit_amount;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        updatePayload.updatedById = currentUser.id;

        await journal_lines.update(updatePayload, {transaction});

        
        
        if (data.journal_entry !== undefined) {
            await journal_lines.setJournal_entry(
              
              data.journal_entry,
              
              { transaction }
            );
        }
        
        if (data.gl_account !== undefined) {
            await journal_lines.setGl_account(
              
              data.gl_account,
              
              { transaction }
            );
        }
        
        if (data.item !== undefined) {
            await journal_lines.setItem(
              
              data.item,
              
              { transaction }
            );
        }
        
        if (data.production_order !== undefined) {
            await journal_lines.setProduction_order(
              
              data.production_order,
              
              { transaction }
            );
        }
        
        if (data.supplier !== undefined) {
            await journal_lines.setSupplier(
              
              data.supplier,
              
              { transaction }
            );
        }
        
        if (data.customer !== undefined) {
            await journal_lines.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        

        
        

        

        return journal_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of journal_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of journal_lines) {
                await record.destroy({transaction});
            }
        });


        return journal_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findByPk(id, options);

        await journal_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await journal_lines.destroy({
            transaction
        });

        return journal_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const journal_lines = await db.journal_lines.findOne(
            { where },
            { transaction },
        );

        if (!journal_lines) {
            return journal_lines;
        }

        const output = journal_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.journal_entry = await journal_lines.getJournal_entry({
            transaction
        });
        
        
        output.gl_account = await journal_lines.getGl_account({
            transaction
        });
        
        
        output.item = await journal_lines.getItem({
            transaction
        });
        
        
        output.production_order = await journal_lines.getProduction_order({
            transaction
        });
        
        
        output.supplier = await journal_lines.getSupplier({
            transaction
        });
        
        
        output.customer = await journal_lines.getCustomer({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.journal_entries,
        as: 'journal_entry',
        
        where: filter.journal_entry ? {
          [Op.or]: [
            { id: { [Op.in]: filter.journal_entry.split('|').map(term => Utils.uuid(term)) } },
            {
              journal_number: {
                [Op.or]: filter.journal_entry.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.gl_accounts,
        as: 'gl_account',
        
        where: filter.gl_account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.gl_account.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.gl_account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.items,
        as: 'item',
        
        where: filter.item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.production_orders,
        as: 'production_order',
        
        where: filter.production_order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.production_order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.production_order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.suppliers,
        as: 'supplier',
        
        where: filter.supplier ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.supplier.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'journal_lines',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.debit_amountRange) {
                const [start, end] = filter.debit_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    debit_amount: {
                    ...where.debit_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    debit_amount: {
                    ...where.debit_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.credit_amountRange) {
                const [start, end] = filter.credit_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    credit_amount: {
                    ...where.credit_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    credit_amount: {
                    ...where.credit_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.journal_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'journal_lines',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.journal_lines.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

